(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define([], factory);
	else if(typeof exports === 'object')
		exports["jsDataStructure"] = factory();
	else
		root["jsDataStructure"] = factory();
})(this, function() {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var Graph = __webpack_require__(1);
	var Queue = __webpack_require__(2);
	var BinarySearchTree = __webpack_require__(3);
	var Search = __webpack_require__(4);
	var Sorting = __webpack_require__(5);
	
	module.exports = {
	  Graph: Graph,
	  Queue: Queue,
	  BinarySearchTree: BinarySearchTree,
	  Search: Search,
	  Sorting: Sorting
	};

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /* eslint no-param-reassign: ["error", { "props": false }] */
	
	var _queue = __webpack_require__(2);
	
	var _queue2 = _interopRequireDefault(_queue);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var Graph = function () {
	  function Graph() {
	    _classCallCheck(this, Graph);
	
	    this.vertices = [];
	    this.adjList = {};
	  }
	
	  _createClass(Graph, [{
	    key: 'addVertex',
	    value: function addVertex(v) {
	      this.vertices.push(v);
	      this.adjList[v] = [];
	    }
	  }, {
	    key: 'addEdge',
	    value: function addEdge(v, w) {
	      this.adjList[v].push(w);
	    }
	  }, {
	    key: 'toString',
	    value: function toString() {
	      var s = '';
	      for (var i = 0; i < this.vertices.length; i += 1) {
	        s += this.vertices[i];
	        s += ' -> ';
	        var neighbors = this.adjList[this.vertices[i]];
	        for (var j = 0; j < neighbors.length; j += 1) {
	          s += neighbors[j];
	          if (j !== neighbors.length - 1) {
	            s += ' ';
	          }
	        }
	        s += '\n';
	      }
	      return s;
	    }
	
	    /**
	     * Breath-first search (BFS), first widely, then deeply.
	     * start traversing the graph from the first specified vertex,
	     * will visit all its neighbors first, then the next layer (neighbor's neighbor)
	     * @method bfs
	     * @param {Object} v - the first vertex to start the bfs
	     * @param {Function} callback - callback function when visiting the vertex
	     * @return {Object} there are 2 property in the return object:
	     *    distances - degree of each vertex in the path
	     *    predecessors - predecessor of the vertex
	     */
	
	  }, {
	    key: 'bfs',
	    value: function bfs(v, callback) {
	      var visitingQueue = new _queue2.default();
	      var visited = {};
	      var distances = {};
	      var predecessors = {};
	
	      if (this.vertices.indexOf(v) >= 0) {
	        visitingQueue.enqueue(v);
	        visited[v] = 'inprogress';
	        predecessors[v] = null;
	        distances[v] = 0;
	        while (!visitingQueue.isEmpty()) {
	          var u = visitingQueue.dequeue();
	          var neighbors = this.adjList[u];
	          for (var i = 0; i < neighbors.length; i += 1) {
	            var w = neighbors[i];
	            if (!visited[w]) {
	              visitingQueue.enqueue(w);
	              visited[w] = 'inprogress';
	              distances[w] = distances[u] + 1;
	              predecessors[w] = u;
	            }
	          }
	          visited[u] = 'done';
	          if (callback) {
	            callback(u);
	          }
	        }
	      }
	      return {
	        distances: distances,
	        predecessors: predecessors
	      };
	    }
	
	    /**
	     * Breath-first search (BFS), first widely, then deeply.
	     * start traversing the graph from the first specified vertex,
	     * will visit all its neighbors first, then the next layer (neighbor's neighbor)
	     * @method bfs
	     * @param {Function} callback - callback function when visiting the vertex
	     * @return {Array} shortest path in array format. Empty array means no shortest path
	     */
	
	  }, {
	    key: 'getShortestPath',
	    value: function getShortestPath(sourceVertex, destVertex) {
	      if (!{}.hasOwnProperty.call(this.adjList, sourceVertex) || !{}.hasOwnProperty.call(this.adjList, destVertex)) {
	        // vertex not exist
	        return [];
	      }
	
	      // use bfs to get the predecessors
	      var path = [];
	
	      var _bfs = this.bfs(sourceVertex, function (vertex) {
	        path.push(vertex);
	      }),
	          predecessors = _bfs.predecessors;
	
	      // check if there is path to the destVertex
	
	
	      if (path.indexOf(destVertex) === -1) {
	        return [];
	      }
	
	      // generate the shortest path
	      var shortestPath = [];
	
	      var v = destVertex;
	      while (v !== sourceVertex) {
	        shortestPath.push(v);
	        v = predecessors[v];
	      }
	      shortestPath.push(sourceVertex);
	      return shortestPath.reverse();
	    }
	
	    /**
	     * Depth-first search (DFS), first deeply, then widely.
	     * start traversing the graph from the first specified vertex,
	     * will follow the path until last vertex of the path is visited,
	     * then will backtrack the next path
	     * @method dfs
	     * @param {Object} v - the first vertex to start the dfs
	     * @param {Function} callback - callback function when visiting the vertex
	     * @return {Object} there are 3 property in the return object:
	     *    discovery - the discovery time
	     *    finished - the time marked as finish
	     *    predecessors - predecessor of the vertex
	     */
	
	  }, {
	    key: 'dfs',
	    value: function dfs(vertex, callback) {
	      var visited = {};
	      var discovery = {};
	      var finished = {};
	      var predecessors = {};
	      var counter = 0;
	
	      if (this.vertices.indexOf(vertex) >= 0) {
	        predecessors[vertex] = null;
	        this.dfsVisit(vertex, visited, discovery, finished, predecessors, counter, callback);
	      }
	
	      return {
	        discovery: discovery,
	        finished: finished,
	        predecessors: predecessors
	      };
	    }
	
	    /**
	     * The recursive function to DFS traverse the vertices
	     * @method dfsVisit
	     * @param {Object} v - the current visiting vertex
	     * @param {Object} visited - dictionary for marking the node visited or not
	     * @param {Object} discovery - dictionary for vertex discovery time
	     * @param {Object} finished - dictionary for vertex finish visit time
	     * @param {Integer} counter - the current step
	     * @param {Function} callback - callback function when visiting the vertex
	     * @return {Integer} The total step of the node visit or finish
	     */
	
	  }, {
	    key: 'dfsVisit',
	    value: function dfsVisit(v, visited, discovery, finished, predecessors, counter, callback) {
	      visited[v] = true;
	      var time = counter + 1;
	      discovery[v] = time;
	      // console.log(`discovered ${v}`);
	      if (callback) {
	        callback(v);
	      }
	      var neighbors = this.adjList[v];
	      for (var i = 0; i < neighbors.length; i += 1) {
	        var u = neighbors[i];
	        if (!visited[u]) {
	          predecessors[u] = v;
	          time = this.dfsVisit(u, visited, discovery, finished, predecessors, time, callback);
	        }
	      }
	      time += 1;
	      finished[v] = time;
	      // console.log(`explored ${v}`);
	      return time;
	    }
	  }]);
	
	  return Graph;
	}();
	
	module.exports = Graph;

/***/ },
/* 2 */
/***/ function(module, exports) {

	"use strict";
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var Queue = function () {
	  function Queue() {
	    _classCallCheck(this, Queue);
	
	    this.items = [];
	  }
	
	  /**
	   * Add an item to the queue
	   * @method enqueue
	   * @param {Object} item - item to be queued
	   * @return {Void}
	   */
	
	
	  _createClass(Queue, [{
	    key: "enqueue",
	    value: function enqueue(element) {
	      this.items.push(element);
	    }
	
	    /**
	     * Remove the first a item of the queue, and return it
	     * @method dequeue
	     * @return {Object} the first item in the queue
	     */
	
	  }, {
	    key: "dequeue",
	    value: function dequeue() {
	      return this.items.shift();
	    }
	
	    /**
	     * Return the first a item of the queue
	     * @method front
	     * @return {Object} the first item in the queue
	     */
	
	  }, {
	    key: "front",
	    value: function front() {
	      return this.items[0];
	    }
	
	    /**
	     * Check if the queue is empty
	     * @method isEmpty
	     * @return {Boolean} if the queue is empty or not
	     */
	
	  }, {
	    key: "isEmpty",
	    value: function isEmpty() {
	      return this.items.length === 0;
	    }
	
	    /**
	     * Remove all items in the queue
	     * @method clear
	     * @return {Void}
	     */
	
	  }, {
	    key: "clear",
	    value: function clear() {
	      this.items = [];
	    }
	
	    /**
	     * Get the size of the queue
	     * @method size
	     * @return {Number} the size of the queue
	     */
	
	  }, {
	    key: "size",
	    value: function size() {
	      return this.items.length;
	    }
	
	    /**
	     * Get the queue item in string format
	     * @method toString
	     * @return {String} The string value of the queue
	     */
	
	  }, {
	    key: "toString",
	    value: function toString() {
	      return JSON.stringify(this.items);
	    }
	  }]);
	
	  return Queue;
	}();
	
	module.exports = Queue;

/***/ },
/* 3 */
/***/ function(module, exports) {

	"use strict";
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/* eslint no-param-reassign: ["error", { "props": false }] */
	
	var Node = function Node(key) {
	  _classCallCheck(this, Node);
	
	  this.key = key;
	  this.left = null;
	  this.right = null;
	};
	
	var BinarySearchTree = function () {
	  function BinarySearchTree() {
	    _classCallCheck(this, BinarySearchTree);
	
	    this.root = null;
	  }
	
	  /**
	   * Add an object to the tree
	   * @method insert
	   * @param {Object} key - the new object to be inserted to the tree
	   * @return {Void}
	   */
	
	
	  _createClass(BinarySearchTree, [{
	    key: "insert",
	    value: function insert(key) {
	      var node = new Node(key);
	      if (!this.root) {
	        this.root = node;
	      } else {
	        this.insertNode(this.root, node);
	      }
	    }
	
	    /**
	     * Add a new node to the specific node
	     * @method insertNode
	     * @param {Node} node - parent node to be insert into
	     * @param {Node} newNode - new node to be inserted
	     * @return {Void}
	     */
	
	  }, {
	    key: "insertNode",
	    value: function insertNode(node, newNode) {
	      if (newNode.key < node.key) {
	        if (!node.left) {
	          node.left = newNode;
	        } else {
	          this.insertNode(node.left, newNode);
	        }
	      } else if (!node.right) {
	        node.right = newNode;
	      } else {
	        this.insertNode(node.right, newNode);
	      }
	    }
	
	    /**
	     * in-order traverse a tree, visit the node in ascending order.
	     * @method inOrderTraverse
	     * @param {Function} callback - the callback function to be executed
	     * @return {Void}
	     */
	
	  }, {
	    key: "inOrderTraverse",
	    value: function inOrderTraverse(callback) {
	      this.inOrderTraverseNode(this.root, callback);
	    }
	
	    /**
	     * Recersive function to in-order traverse a tree for specific node
	     * @method inOrderTraverseNode
	     * @param {Node} node - target node to be traversed
	     * @param {Function} callback - the callback function to be executed
	     * @return {Void}
	     */
	
	  }, {
	    key: "inOrderTraverseNode",
	    value: function inOrderTraverseNode(node, callback) {
	      if (node !== null) {
	        this.inOrderTraverseNode(node.left, callback);
	        callback(node);
	        this.inOrderTraverseNode(node.right, callback);
	      }
	    }
	
	    /**
	     * pre-order traverse a tree, the root is the first node visited.
	     * @method preOrderTraverse
	     * @param {Function} callback - the callback function to be executed
	     * @return {Void}
	     */
	
	  }, {
	    key: "preOrderTraverse",
	    value: function preOrderTraverse(callback) {
	      this.preOrderTraverseNode(this.root, callback);
	    }
	
	    /**
	     * Recersive function to pre-order traverse a tree for specific node
	     * @method preOrderTraverseNode
	     * @param {Node} node - target node to be traversed
	     * @param {Function} callback - the callback function to be executed
	     * @return {Void}
	     */
	
	  }, {
	    key: "preOrderTraverseNode",
	    value: function preOrderTraverseNode(node, callback) {
	      if (node !== null) {
	        callback(node);
	        this.preOrderTraverseNode(node.left, callback);
	        this.preOrderTraverseNode(node.right, callback);
	      }
	    }
	
	    /**
	     * post-order traverse a tree, the root is the last node visited.
	     * @method postOrderTraverse
	     * @param {Function} callback - the callback function to be executed
	     * @return {Void}
	     */
	
	  }, {
	    key: "postOrderTraverse",
	    value: function postOrderTraverse(callback) {
	      this.postOrderTraverseNode(this.root, callback);
	    }
	
	    /**
	     * Recersive function to post-order traverse a tree for specific node
	     * @method postOrderTraverseNode
	     * @param {Node} node - target node to be traversed
	     * @param {Function} callback - the callback function to be executed
	     * @return {Void}
	     */
	
	  }, {
	    key: "postOrderTraverseNode",
	    value: function postOrderTraverseNode(node, callback) {
	      if (node !== null) {
	        this.postOrderTraverseNode(node.left, callback);
	        this.postOrderTraverseNode(node.right, callback);
	        callback(node);
	      }
	    }
	
	    /**
	     * Get the min node of the tree
	     * @method min
	     * @return {Object} The min value (object) of the tree
	     */
	
	  }, {
	    key: "min",
	    value: function min() {
	      var minimumNode = BinarySearchTree.minNode(this.root);
	      if (minimumNode !== null) {
	        return minimumNode.key;
	      }
	      return null;
	    }
	
	    /**
	     * Get the min node of specific node (sub-tree)
	     * @method minNode
	     * @param {Node} node - the callback function to be executed
	     * @return {Node} the smallest node
	     */
	
	  }, {
	    key: "max",
	
	
	    /**
	     * Get the max node of the tree
	     * @method max
	     * @return {Object} The max value (object) of the tree
	     */
	    value: function max() {
	      var maximumNode = BinarySearchTree.maxNode(this.root);
	      if (maximumNode !== null) {
	        return maximumNode.key;
	      }
	      return null;
	    }
	
	    /**
	     * Get the max node of specific node (sub-tree)
	     * @method maxNode
	     * @param {Node} node - the callback function to be executed
	     * @return {Node} the largest node
	     */
	
	  }, {
	    key: "search",
	
	
	    /**
	     * Search a object or value in the tree
	     * @method search
	     * @param {Object} key - The object or value to search for
	     * @return {Boolean} if the key is found
	     */
	    value: function search(key) {
	      return this.searchNode(this.root, key);
	    }
	
	    /**
	     * Recursive search function to find a object or value in the node
	     * @method searchNode
	     * @param {Node} node - node to be searched for the key
	     * @param {Object} key - The object or value to search for
	     * @return {Boolean} if the key is found
	     */
	
	  }, {
	    key: "searchNode",
	    value: function searchNode(node, key) {
	      if (node === null) {
	        return false;
	      }
	
	      if (key < node.key) {
	        return this.searchNode(node.left, key);
	      } else if (key > node.key) {
	        return this.searchNode(node.right, key);
	      }
	
	      return key === node.key;
	    }
	
	    /**
	     * Remove a object or value in the tree
	     * @method remove
	     * @param {Object} key - The object or value to be removed
	     * @return {Void}
	     */
	
	  }, {
	    key: "remove",
	    value: function remove(key) {
	      this.root = this.removeNode(this.root, key);
	    }
	
	    /**
	     * Remove a object or value in the sub-tree
	     * @method removeNode
	     * @param {Node} node - the root of the sub tree
	     * @param {Object} key - The object or value to be removed
	     * @return {Node} the new tree after removing the key
	     */
	
	  }, {
	    key: "removeNode",
	    value: function removeNode(node, key) {
	      var pointer = node;
	      if (pointer === null) {
	        return null;
	      }
	
	      if (key < pointer.key) {
	        pointer.left = this.removeNode(pointer.left, key);
	        return pointer;
	      } else if (key > pointer.key) {
	        pointer.right = this.removeNode(pointer.right, key);
	        return pointer;
	      } else if (key !== pointer.key) {
	        // key value not exist in the tree
	        return pointer;
	      }
	
	      if (pointer.left === null && pointer.right === null) {
	        // the target node is a leaf
	        pointer = null;
	        return pointer;
	      }
	
	      // the target node has one child
	      if (pointer.left === null) {
	        pointer = pointer.right;
	        return pointer;
	      } else if (pointer.right === null) {
	        pointer = pointer.left;
	        return pointer;
	      }
	
	      // the target node has 2 children
	      // get the smallest node from the right sub-tree
	      var temp = BinarySearchTree.minNode(pointer.right);
	      pointer.key = temp.key;
	      // recursively update the right child,
	      // it will be the new tree with the smallest item removed.
	      pointer.right = this.removeNode(pointer.right, temp.key);
	      return pointer;
	    }
	  }], [{
	    key: "minNode",
	    value: function minNode(node) {
	      var pointer = node;
	      if (pointer) {
	        while (pointer && pointer.left !== null) {
	          pointer = pointer.left;
	        }
	        return pointer;
	      }
	      return null;
	    }
	  }, {
	    key: "maxNode",
	    value: function maxNode(node) {
	      var pointer = node;
	      if (pointer) {
	        while (pointer && pointer.right !== null) {
	          pointer = pointer.right;
	        }
	        return pointer;
	      }
	      return null;
	    }
	  }]);
	
	  return BinarySearchTree;
	}();
	
	module.exports = BinarySearchTree;

/***/ },
/* 4 */
/***/ function(module, exports) {

	"use strict";
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	var Search = function () {
	  function Search() {
	    _classCallCheck(this, Search);
	  }
	
	  _createClass(Search, null, [{
	    key: "sequentialSearch",
	
	
	    /**
	     * Sequentially search an item in the array
	     * Complexity: Θ(n)
	     * Space Complexity: O(n)
	     * @method sequentialSearch
	     * @param {Array} array - input array
	     * @param {Object} item - target item to be searched
	     * @return {Integer} index of the item if founded
	     */
	    value: function sequentialSearch(array, item) {
	      if (!array || array.length === 0) {
	        return -1;
	      }
	      for (var i = 0; i < array.length; i += 1) {
	        if (item === array[i]) {
	          return i;
	        }
	      }
	      return -1;
	    }
	
	    /**
	     * Binary search an item in the array
	     * Complexity: Θ(log(n))
	     * Space Complexity: O(n)
	     * @method binarySearch
	     * @param {Array} array - input array
	     * @param {Object} item - target item to be searched
	     * @return {Integer} index of the item if founded
	     */
	
	  }, {
	    key: "binarySearch",
	    value: function binarySearch(array, item) {
	      if (!array || array.length === 0) {
	        return -1;
	      }
	      var low = 0;
	      var high = array.length - 1;
	      var mid = void 0;
	      var element = void 0;
	
	      while (low <= high) {
	        mid = Math.floor((low + high) / 2);
	        element = array[mid];
	        if (element < item) {
	          low = mid + 1;
	        } else if (element > item) {
	          high = mid - 1;
	        } else {
	          return element === item ? mid : -1;
	        }
	      }
	
	      return -1;
	    }
	  }]);
	
	  return Search;
	}();
	
	module.exports = Search;

/***/ },
/* 5 */
/***/ function(module, exports) {

	"use strict";
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	/* eslint no-param-reassign: ["error", { "props": false }] */
	
	var Sorting = function () {
	  function Sorting() {
	    _classCallCheck(this, Sorting);
	  }
	
	  _createClass(Sorting, null, [{
	    key: "bubbleSort",
	
	
	    /**
	     * bubble sort
	     * Complexity: Θ(n^2)
	     * Space Complexity: O(1)
	     * @method bubbleSort
	     * @param {Array} array - input array
	     * @return {Array} sorted array
	     */
	    value: function bubbleSort(array) {
	      if (!array || !array.length) {
	        return array;
	      }
	      for (var i = 0; i < array.length - 1; i += 1) {
	        for (var j = i + 1; j < array.length; j += 1) {
	          if (array[i] > array[j]) {
	            var temp = array[i];
	            array[i] = array[j];
	            array[j] = temp;
	          }
	        }
	      }
	      return array;
	    }
	
	    /**
	     * selection sort
	     * Complexity: Θ(n^2)
	     * Space Complexity: O(1)
	     * @method selectionSort
	     * @param {Array} array - input array
	     * @return {Array} sorted array
	     */
	
	  }, {
	    key: "selectionSort",
	    value: function selectionSort(array) {
	      if (!array || !array.length) {
	        return array;
	      }
	      var indexMin = 0;
	      for (var i = 0; i < array.length - 1; i += 1) {
	        indexMin = i;
	        for (var j = i; j < array.length; j += 1) {
	          if (array[indexMin] > array[j]) {
	            indexMin = j;
	          }
	        }
	        if (i !== indexMin) {
	          var temp = array[i];
	          array[i] = array[indexMin];
	          array[indexMin] = temp;
	        }
	      }
	      return array;
	    }
	
	    /**
	     * insertion sort
	     * Complexity: Θ(n^2)
	     * Space Complexity: O(1)
	     * @method insertionSort
	     * @param {Array} array - input array
	     * @return {Array} sorted array
	     */
	
	  }, {
	    key: "insertionSort",
	    value: function insertionSort(array) {
	      if (!array || !array.length) {
	        return array;
	      }
	      var temp = 0;
	      var j = 0;
	      for (var i = 1; i < array.length; i += 1) {
	        j = i;
	        temp = array[i];
	        while (j > 0 && array[j - 1] > temp) {
	          array[j] = array[j - 1];
	          j -= 1;
	        }
	        array[j] = temp;
	      }
	      return array;
	    }
	
	    /**
	     * merge sort
	     * Complexity: O(n log n)
	     * Space Complexity: O(n)
	     * @method mergeSort
	     * @param {Array} array - input array
	     * @return {Array} sorted array
	     */
	
	  }, {
	    key: "mergeSort",
	    value: function mergeSort(array) {
	      if (!array || !array.length || array.length === 1) {
	        return array;
	      }
	      var length = array.length;
	      var mid = Math.floor(length / 2);
	      var left = array.slice(0, mid);
	      var right = array.slice(mid, length);
	
	      return this.merge(this.mergeSort(left), this.mergeSort(right));
	    }
	
	    /**
	     * merge two arrays, and return a new shorted array
	     * @method merge
	     * @param {Array} left - first half of the array
	     * @param {Array} right - second half of the array
	     * @return {Array} sorted array
	     */
	
	  }, {
	    key: "merge",
	    value: function merge(left, right) {
	      var result = [];
	      var il = 0;
	      var ir = 0;
	
	      while (il < left.length && ir < right.length) {
	        if (left[il] < right[ir]) {
	          result.push(left[il]);
	          il += 1;
	        } else {
	          result.push(right[ir]);
	          ir += 1;
	        }
	      }
	
	      while (il < left.length) {
	        result.push(left[il]);
	        il += 1;
	      }
	
	      while (ir < right.length) {
	        result.push(right[ir]);
	        ir += 1;
	      }
	
	      return result;
	    }
	
	    /**
	     * quick sort
	     * Complexity: O(n log(n))
	     * Space Complexity: O(Log(n))
	     * @method quickSort
	     * @param {Array} array - input array
	     * @return {Array} sorted array
	     */
	
	  }, {
	    key: "quickSort",
	    value: function quickSort(array) {
	      if (!array || !array.length) {
	        return array;
	      }
	      this.quick(array, 0, array.length - 1);
	      return array;
	    }
	
	    /**
	     * Recursive method to perform the quick sort
	     * @method quick
	     * @param {Array} array - input array
	     * @param {Integer} left - left pointer
	     * @param {Integer} right - right pointer
	     * @return {Void}
	     */
	
	  }, {
	    key: "quick",
	    value: function quick(array, left, right) {
	      if (array.length > 1) {
	        var index = this.partition(array, left, right);
	        if (left < index - 1) {
	          this.quick(array, left, index - 1);
	        }
	        if (index < right) {
	          this.quick(array, index, right);
	        }
	      }
	    }
	
	    /**
	     * get the index of the left pointer that will be used to create the sub-arrays
	     * @method partition
	     * @param {Array} array - input array
	     * @param {Integer} left - left pointer
	     * @param {Integer} right - right pointer
	     * @return {Integer} pivot
	     */
	
	  }, {
	    key: "partition",
	    value: function partition(array, left, right) {
	      // get the pivot as the middle item of the array
	      var pivot = array[Math.floor((right + left) / 2)];
	      var i = left;
	      var j = right;
	
	      while (i <= j) {
	        // move the left pointer until we find item is greater than the pivot
	        while (array[i] < pivot) {
	          i += 1;
	        }
	
	        // move the right pointer until we find item is smaller than the pivot
	        while (array[j] > pivot) {
	          j -= 1;
	        }
	
	        if (i <= j) {
	          if (i !== j) {
	            // if left pointer is smaller than the right pointer,
	            // swap the items
	            var temp = array[i];
	            array[i] = array[j];
	            array[j] = temp;
	          }
	          i += 1;
	          j -= 1;
	        }
	      }
	      return i;
	    }
	  }]);
	
	  return Sorting;
	}();
	
	module.exports = Sorting;

/***/ }
/******/ ])
});
;
//# sourceMappingURL=index.umd.js.map